#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define BUFFSIZE 256

main (int argc, char* argv[])
{
	char buff1[BUFFSIZE], buff2[BUFFSIZE];
	FILE *f1, *f2;
	long offset[1000];	// the position of each line in file1
	int key;			// the desired order from file2
	int i;
	
	if (argc < 3)
	{
		puts("Usage: zigsort file1 file2");
		puts("Sort file1 according to the 3-digit key field of file2");
		exit (1);
	}
	
	f1 = fopen(argv[1], "r");
	if (f1 == NULL) exit (1);
	
	i = 0; offset[0] = 0;			// the start of the first line
	while ( fgets(buff1, BUFFSIZE, f1) != NULL )
		offset[++i] = ftell(f1);	// the start of the next line

	f2 = fopen(argv[2], "r");
	if (f2 == NULL) exit (1);
	
	while ( fgets(buff2, BUFFSIZE, f2) != NULL )
	{
		buff2[3]=0;  			// null terminator after 3 digits
		key = atoi(buff2) - 1;  // offset array starts at zero
		fseek(f1, offset[key], 0);
		fgets(buff1, BUFFSIZE, f1);
		*(strchr(buff1, '\n')) = 0;	//kill the newline at the end of the string
		puts(buff1);
	}
	fclose (f1); fclose(f2);
	exit (0);
}
